/**
 ##############################################################################
 # Copyright (C) 2006-2010 INRIA
 #
 # This library is free software; you can redistribute it and/or
 # modify it under the terms of the GNU Lesser General Public
 # License as published by the Free Software Foundation; either
 # version 2 of the License, or (at your option) any later version.
 #
 # This library is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 # Lesser General Public License for more details.
 #
 # You should have received a copy of the GNU Lesser General Public
 # License along with this library; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ##############################################################################
 * 
 */
package fr.inria.icocoa.bpelgenerator;

import fr.inria.icocoa.exception.SDSDCAEException;

/**
 * GenerationException.java This king of exception is throwed when an error
 * occurs during Generation or deployment of BPEL script
 * 
 * @author <a href="mailto:sebastien.bianco@inria.fr">sebastien bianco</a> - <a
 *         href="http://www-rocq.inria.fr/arles">Arles Project - INRIA</a>
 * 
 * Creation Date : Jan 2, 2007 2:03:18 PM
 */
public class GenerationException extends SDSDCAEException {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public GenerationException() {
		super();
	}

	public GenerationException(String message) {
		super(message);
	}

	public GenerationException(String message, Throwable cause) {
		super(message, cause);
	}

	public GenerationException(Throwable cause) {
		super(cause);
	}

}
