/**
 ##############################################################################
 # Copyright (C) 2006-2010 INRIA
 #
 # This library is free software; you can redistribute it and/or
 # modify it under the terms of the GNU Lesser General Public
 # License as published by the Free Software Foundation; either
 # version 2 of the License, or (at your option) any later version.
 #
 # This library is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 # Lesser General Public License for more details.
 #
 # You should have received a copy of the GNU Lesser General Public
 # License along with this library; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ##############################################################################
 * 
 */
package fr.inria.icocoa.test.sampleservices;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import org.apache.log4j.Logger;

/**
 * The object of this WS is to copy the sent String in a jws file in axis
 * directory.
 * 
 * <p color="#FF0000">
 * !!!WARNING!!!
 * </p>
 * <ul>
 * <li>the environment variable CATALINA_HOME needs to be set on the root
 * repository of Tomcat</li>
 * <li>deploy this WS under tomcat 5.x</li>
 * </ul>
 * 
 * @author <a href="mailto:sebastien.bianco@inria.fr">sebastien bianco</a> - <a
 *         href="http://www-rocq.inria.fr/arles">Arles Project - INRIA</a>
 * 
 * 
 * Creation Date : Nov 20, 2007 3:04:35 PM
 */
public class CreateWS {

	public String createService(String javaFile, String javaName) {
		Logger logger = Logger.getLogger(CreateWS.class);
		logger.info("CreatWS::createService. The parameter value is:\n "
				+ javaFile);

		String catalinapath = System.getProperty("user.dir");
		String serverSeparator = System.getProperty("file.separator");

		String axisDir = catalinapath + serverSeparator + "webapps"
				+ serverSeparator + "axis" + serverSeparator;
		String filename = axisDir + javaName + ".jws";

		File file = new File(filename);

		try {
			if (file.exists()) {
				file.delete();
			}
			file.createNewFile();

			BufferedWriter out = new BufferedWriter(new FileWriter(file));
			out.write(javaFile);
			out.flush();
			out.close();

			java.net.InetAddress localMachine = java.net.InetAddress.getLocalHost();

			return "http://" + localMachine.getHostName() + ":9080/axis/"
					+ javaName + ".jws : Service Deployed";
		} catch (IOException e) {

			e.printStackTrace();
			return "Error during deployement -> " + e.getLocalizedMessage();
		}

	}

}
