/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.inria.icocoa.test.semreptest;

import fr.inria.icocoa.common.DebugPrinter;
import fr.inria.icocoa.common.MeasurementTool;
import fr.inria.icocoa.common.Tools;
import fr.inria.icocoa.compositionengine.CompositionEngine;
import fr.inria.icocoa.semrep.CapabilityInvoker;
import fr.inria.icocoa.semrep.SemanticRepositoryFactory;
import fr.inria.icocoa.semrep.SemanticRepositoryForCompositionEngine;

/**
 * 
 * @author bianco
 */
public class AlarmClockCompositionTest {

	private static String userDir = System.getProperty("user.dir");
	private static String slash = System.getProperty("file.separator");
	private static SemanticRepositoryForCompositionEngine repository = null;

	public static void main(String[] args) {
		repository = SemanticRepositoryFactory.getInstanceCE();
		repository.clearRepository();

		/*String[] semDescs = { "amigo-s" + slash + "ServiceA.owl",
				"amigo-s" + slash + "ServiceB.owl",
				"amigo-s" + slash + "ServiceC.owl",
				"amigo-s" + slash + "ServiceD.owl",
				"amigo-s" + slash + "SimpleService.owl",
				"amigo-s" + slash + "CompositeService.owl",
				"amigo-s" + slash + "CoffeeMachine.owl",
				"amigo-s" + slash + "FmRadio.owl",
				"amigo-s" + slash + "GetPiPart1Service.owl",
				"amigo-s" + slash + "GetPiPart2Service.owl",
				"amigo-s" + slash + "PiLowService.owl",
				"amigo-s" + slash + "SebEchoService.owl",
				"amigo-s" + slash + "MultimediaBrowser.owl",
				"amigo-s" + slash + "VerySimpleService.owl" };
		String[] wsdls = { "wsdl" + slash + "ServiceA.wsdl",
				"wsdl" + slash + "ServiceB.wsdl",
				"wsdl" + slash + "ServiceC.wsdl",
				"wsdl" + slash + "ServiceD.wsdl",
				"wsdl" + slash + "SimpleService.wsdl",
				"wsdl" + slash + "CompositeService.wsdl",
				"wsdl" + slash + "CoffeeMachine.wsdl",
				"wsdl" + slash + "FmRadio.wsdl",
				"wsdl" + slash + "GetPiPart1Service.wsdl",
				"wsdl" + slash + "GetPiPart2Service.wsdl",
				"wsdl" + slash + "PiLowService.wsdl",
				"wsdl" + slash + "SebEchoService.wsdl",
				"wsdl" + slash + "MultimediaBrowser.wsdl",
				"wsdl" + slash + "VerySimpleService.wsdl" };*/
		
		String[] semDescs = { 
				"amigo-s" + slash + "CoffeeMachineComposite.owl",
				"amigo-s" + slash + "FmRadioComposite.owl" 
				//"amigo-s" + slash + "CoffeeMachine.owl",
				//"amigo-s" + slash + "FmRadio.owl"
		};
		String[] wsdls = { 
				"wsdl" + slash + "CoffeeMachine.wsdl",
				"wsdl" + slash + "FmRadio.wsdl" };
		String[] uuids = new String[semDescs.length];

		// SemanticRepository repository =
		// SemanticRepositoryFactory.getInstance();

		repository.clearRepository();

		DebugPrinter.print("Registration of all services", DebugPrinter.INFO);
		for (int i = 0; i < semDescs.length; ++i) {
			DebugPrinter.print("> Registering " + semDescs[i],
				DebugPrinter.INFO);
			try {
				uuids[i] = repository.addService(semDescs[i], wsdls[i]);
			} catch (Exception e) {
				// System.err.println("Couldn't add service: " + e);
				// e.printStackTrace();
				DebugPrinter.print(e, DebugPrinter.WARN);
			}
		}
		DebugPrinter.print("End of registration.", DebugPrinter.INFO);

		// repository.getServiceObjectWithLocalName("http://chico1:9080/axis/services/CoffeeMachine.owl#CoffeeMachine").print(System.err);
		// repository.getServiceObjectWithLocalName("http://chico1:9080/axis/services/FmRadio.owl#FmRadio").print(System.err);

		String SDLFilenameA = userDir + slash + "amigo-s" + slash
				+ "AlarmClockTask.owl";
		
		try {
			/*Long time = System.currentTimeMillis();
			UserTask task = new UserTask(SDL2ServiceParser.parseProcess(
				SDLFilenameA, false));
			time = System.currentTimeMillis() - time;
			Tools.displayTime("Task Parsing :", time);
			task.print(System.out);
			time = System.currentTimeMillis();
			List<String> deployedServices = ce.deployProcessAsService(task);
			time = System.currentTimeMillis() - time;
			Tools.displayTime("Service composition :", time);
			DebugPrinter.print(deployedServices, "deployedServices",
				DebugPrinter.INFO);*/
			Long time = System.currentTimeMillis();			
			String[] taskAMatches = repository.getServicesForTask(Tools.getURIStringFromFilePath(SDLFilenameA));
			time = System.currentTimeMillis() - time;
			MeasurementTool.displayTime("Service composition :", time);
			for (String serviceMatch : taskAMatches) {
				System.out.printf("Using %s for Task A:\n", serviceMatch);
				String wsdl = repository.getWsdlForService(serviceMatch);
				CapabilityInvoker taskAInvoker = new CapabilityInvoker(wsdl);
				taskAInvoker.invoke("AlarmClockActivate","107.7");
			}
			
			time = System.currentTimeMillis();			
			taskAMatches = repository.getServicesForTask(Tools.getURIStringFromFilePath(SDLFilenameA));
			time = System.currentTimeMillis() - time;
			MeasurementTool.displayTime("Service composition :", time);
			for (String serviceMatch : taskAMatches) {
				System.out.printf("Using %s for Task A:\n", serviceMatch);
				String wsdl = repository.getWsdlForService(serviceMatch);
				CapabilityInvoker taskAInvoker = new CapabilityInvoker(wsdl);
				taskAInvoker.invoke("AlarmClockActivate","107.7");
			}
			
		} catch (Exception e) {
			DebugPrinter.print(e, DebugPrinter.ERROR);
		}
	}
}
