package fr.inria.icocoa.test.semreptest;

import java.util.List;
import java.util.Map;

import javax.wsdl.Binding;
import javax.wsdl.Definition;
import javax.wsdl.Input;
import javax.wsdl.Message;
import javax.wsdl.Operation;
import javax.wsdl.Output;
import javax.wsdl.Part;
import javax.wsdl.Port;
import javax.wsdl.PortType;
import javax.wsdl.Service;
import javax.wsdl.WSDLException;
import javax.wsdl.factory.WSDLFactory;
import javax.wsdl.xml.WSDLReader;
import javax.xml.namespace.QName;

public class AmigoSGeneratorTest {

	/**
	 * @param args
	 */
	@SuppressWarnings("unchecked")
	public static void main(String[] args) {
		try {
			WSDLFactory factory = WSDLFactory.newInstance();
			WSDLReader reader = factory.newWSDLReader();
			reader.setFeature("javax.wsdl.verbose", true);
			reader.setFeature("javax.wsdl.importDocuments", true);
			Definition wsdlDef = reader.readWSDL(null, "wsdl"
					+ System.getProperty("file.separator") + "ServiceA.wsdl");

			Map<QName, Service> services = wsdlDef.getServices();
			for (Map.Entry<QName, Service> servicesEntry : services.entrySet()) {
				Service s = servicesEntry.getValue();
				Map<QName, Port> ports = s.getPorts();
				for (Map.Entry<QName, Port> portsEntry : ports.entrySet()) {
					Port p = portsEntry.getValue();
					Binding b = p.getBinding();
					PortType pt = b.getPortType();
					List<Operation> ops = pt.getOperations();
					for (Operation op : ops) {
						Input in = op.getInput();
						Message inMsg = in.getMessage();
						Map<QName, Part> inParts = inMsg.getParts();
						for (Map.Entry<QName, Part> entry : inParts.entrySet()) {
							Part inPart = entry.getValue();
						}

						Output out = op.getOutput();
						Message outMsg = out.getMessage();
						Map<QName, Part> outParts = outMsg.getParts();
						for (Map.Entry<QName, Part> entry : outParts.entrySet()) {
							Part outPart = entry.getValue();
						}
					}
				}
			}
		} catch (WSDLException e) {
			e.printStackTrace();
		}
	}
}
