package fr.inria.icocoa.test.semreptest;

import com.thoughtworks.xstream.XStream;

import fr.inria.icocoa.common.DebugPrinter;
import fr.inria.icocoa.common.Tools;
import fr.inria.icocoa.semrep.SemanticRepositoryFactory;
import fr.inria.icocoa.semrep.SemanticRepositoryForCompositionEngine;
import fr.inria.icocoa.servicemodel.Service;
import fr.inria.icocoa.servicemodel.toolsobjects.Couple;

public class XstreamTest {

	// private static String userDir = System.getProperty("user.dir");

	private static String slash = System.getProperty("file.separator");

	private static SemanticRepositoryForCompositionEngine repository = null;

	public static void main(String[] args) {
		repository = SemanticRepositoryFactory.getInstanceCE();

		// String userDir = System.getProperty("user.dir");
		// String slash = System.getProperty("file.separator");

		String[] semDescs = { "amigo-s" + slash + "ServiceA.owl" };
		String[] wsdls = { "wsdl" + slash + "ServiceA.wsdl" };
		String[] uuids = new String[semDescs.length];

		// SemanticRepository repository =
		// SemanticRepositoryFactory.getInstance();

		repository.clearRepository();

		DebugPrinter.print("Registration of all services", DebugPrinter.INFO);
		for (int i = 0; i < semDescs.length; ++i) {
			DebugPrinter.print("> Registering " + semDescs[i],
				DebugPrinter.INFO);
			try {
				uuids[i] = repository.addService(semDescs[i], wsdls[i]);
			} catch (Exception e) {
				// System.err.println("Couldn't add service: " + e);
				// e.printStackTrace();
				DebugPrinter.print(e.getStackTrace(), e.getMessage(),
					DebugPrinter.WARN);
			}
		}
		DebugPrinter.print("End of registration.", DebugPrinter.INFO);
		// repository.displayAllServices();

		Service sa = repository.getServiceObjectWithLocalName("http://amigo.gforge.inria.fr/owl/ServiceA.owl#ServiceA");

		XStream xstream = new XStream();

		/*
		 * xstream.alias("service", Service.class); xstream.alias("capability",
		 * Capability.class); xstream.alias("io", IO.class);
		 * xstream.alias("input", Input.class); xstream.alias("output",
		 * Output.class); xstream.alias("groundingproperty",
		 * GroundingProperty.class); xstream.alias("controlconstruct",
		 * ControlConstruct.class); xstream.alias("property", Property.class);
		 * xstream.alias("qosproperty", QoSProperty.class);
		 * xstream.alias("parameterbinding", ParameterBinding.class);
		 * xstream.alias("couple", Couple.class);
		 */

		String xml = xstream.toXML(sa);

		DebugPrinter.print("xml Stream :\n" + xml, DebugPrinter.INFO);

		Service sb = (Service) xstream.fromXML(xml);

		DebugPrinter.print("Read service :\n" + sb, DebugPrinter.INFO);

		DebugPrinter.print("test equality = " + sa.equals(sb),
			DebugPrinter.INFO);

		Couple<Service, String> couple = new Couple<Service, String>(sa,
				Tools.readFromFile(wsdls[0]));

		String xml2 = xstream.toXML(couple);

		DebugPrinter.print("xml Stream :\n" + xml2, DebugPrinter.INFO);

		Couple<Service, String> couple2 = (Couple<Service, String>) xstream.fromXML(xml2);

		DebugPrinter.print("Read wsdl :\n" + couple2.getSecond(),
			DebugPrinter.INFO);

	}

}
