package vtt.vp.context.source;

import java.io.InputStream;

import vtt.vp.context.ContextEventSubscription;
import vtt.vp.context.VPContextEventListener;

import com.hp.hpl.jena.query.QueryException;
import com.hp.hpl.jena.query.QuerySolution;
import com.hp.hpl.jena.rdf.model.SimpleSelector;
import com.hp.hpl.jena.rdf.model.Statement;

public interface VPContextSource {

	static final int SENSOR_CS_TYPE = 0;
	static final int STATIC_CS_TYPE = 1;
	static final int DYNAMIC_CS_TYPE = 2;
	
	//General methods
	public String getName();
	public String getURI();
	public int getType();
	public String getValueString();
	public InputStream getRDFDataStream();
	
	//Query methods
	public QuerySolution[] doSelectQuery(String qStr) throws QueryException;
	public String doSelectQueryXML(String qStr) throws QueryException;
	public boolean doAskQuery(String qStr) throws QueryException;
	
	//Context event subscription methods
	public ContextEventSubscription subscribeContextEvent(VPContextEventListener cel);
	public ContextEventSubscription subscribeContextEvent(SimpleSelector s, VPContextEventListener cel);
	public ContextEventSubscription subscribeContextEvent(String qStr, VPContextEventListener cel);
	public ContextEventSubscription subscribeConditionalContextEvent(String qStr, VPContextEventListener cel);	
	public void unsubscribe(ContextEventSubscription ces);	
	
	//Modification methods
	public void modify(Statement[] remStmts, Statement[] addStmts);
	
}
