package vtt.vp.gui.context;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.File;
import java.io.FileNotFoundException;

import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.filechooser.FileFilter;

import vtt.vp.context.ContextSourceRepository;
import vtt.vp.context.source.StaticContextSource;
import vtt.vp.context.source.VPContextSource;
import vtt.vp.gui.VantagePointGUI;

public class ContextSourceRepositoryPanel extends JPanel implements MouseListener{

	static final long serialVersionUID = 2;
	
	private VantagePointGUI vpGui;
	//private ContextSourceRepository contextSourceRepository;
	
	public ContextSourceRepositoryPanel(VantagePointGUI vpg) {
		vpGui = vpg;
		//contextSourceRepository = csr;
        initComponents();
    }
    
	/**
	 * Opens up a file chooser and adds a static context source.
	 * @param evt
	 */
	private void addStaticCSButtonActionPerformed(ActionEvent evt) {
				
		int selectOption = rdfFileChooser.showOpenDialog(this);
		
		if(selectOption == JFileChooser.APPROVE_OPTION){
			
			File selectedFile = rdfFileChooser.getSelectedFile();			
			VPContextSource newStaticContextSource;			
			try{				
				newStaticContextSource = new StaticContextSource(selectedFile);
			}catch(FileNotFoundException fnfe){
				vpGui.printMessage("File not found", Color.red);
				return;				
			}			
			csTableModel.addContextSource(newStaticContextSource);				
			
		}
		
	}
	
	/**
	 * Removes the selected context source from available list.
	 * @param evt
	 */
	private void removeButtonActionPerformed(ActionEvent evt){
		
		int selectedRowIndex = csTable.getSelectedRow();
		if(selectedRowIndex == -1) return;
		csTableModel.removeContextSource(selectedRowIndex);
		
	}
	
	/**
	 * Publishes selected context source to Context Source Repository
	 * @param evt
	 */
	private void publishButtonActionPerformed(ActionEvent evt){
		
		int selectedRowIndex = csTable.getSelectedRow();
		if(selectedRowIndex == -1) return;
		VPContextSource vpcs = csTableModel.removeContextSource(selectedRowIndex);
		//contextSourceRepository.registerContextSource(vpcs);
		
	}
	
	/**
	 * Removes a context source from the context source repository.
	 * @param evt
	 */
	private void unpublishButtonActionPerformed(ActionEvent evt){
		
		int selectedRowIndex = csrTable.getSelectedRow();
		if(selectedRowIndex == -1) return;		
		VPContextSource vpcs = csrTableModel.getContextSourceInRow(selectedRowIndex);		
		//contextSourceRepository.unregisterContextSource(vpcs.getName());		
		csTableModel.addContextSource(vpcs);
		
	}
	
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">
	 private void initComponents() {
	        requestPanel = new javax.swing.JPanel();
	        csConceptsComboBox = new javax.swing.JComboBox();
	        requestContextSourceButton = new javax.swing.JButton();
	        tablesPanel = new javax.swing.JPanel();
	        csrPanel = new javax.swing.JPanel();
	        csrScrollPane = new javax.swing.JScrollPane();
	        csrTable = new javax.swing.JTable();
	        unpublishButton = new javax.swing.JButton();
	        csPanel = new javax.swing.JPanel();
	        csScrollPane = new javax.swing.JScrollPane();
	        csTable = new javax.swing.JTable();
	        removeButton = new javax.swing.JButton();
	        addSensorCSButton = new javax.swing.JButton();
	        addStaticCSButton = new javax.swing.JButton();
	        addDynamicCDButton = new javax.swing.JButton();
	        publishButton = new javax.swing.JButton();

	        requestPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Simulate Request"));
	        csConceptsComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

	        requestContextSourceButton.setText("Request");

	        javax.swing.GroupLayout requestPanelLayout = new javax.swing.GroupLayout(requestPanel);
	        requestPanel.setLayout(requestPanelLayout);
	        requestPanelLayout.setHorizontalGroup(
	            requestPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
	            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, requestPanelLayout.createSequentialGroup()
	                .addContainerGap()
	                .addComponent(csConceptsComboBox, 0, 332, Short.MAX_VALUE)
	                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
	                .addComponent(requestContextSourceButton))
	        );
	        requestPanelLayout.setVerticalGroup(
	            requestPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
	            .addGroup(requestPanelLayout.createSequentialGroup()
	                .addGroup(requestPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
	                    .addComponent(requestContextSourceButton)
	                    .addComponent(csConceptsComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
	                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
	        );

	        tablesPanel.setLayout(new javax.swing.BoxLayout(tablesPanel, javax.swing.BoxLayout.Y_AXIS));

	        csrPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Context Source Repository"));
	        csrPanel.setAlignmentY(0.0F);
	        //csrTableModel = new ContextSourceRepositoryTableModel(contextSourceRepository);
	        //csrTable.setModel(csrTableModel);
	        csrTable.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
	        csrScrollPane.setPreferredSize(new Dimension(0,0));
	        csrScrollPane.setViewportView(csrTable);	        

	        unpublishButton.setText("Unpublish");
	        unpublishButton.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent evt) {
					unpublishButtonActionPerformed(evt);					
				}	        	
	        });

	        javax.swing.GroupLayout csrPanelLayout = new javax.swing.GroupLayout(csrPanel);
	        csrPanel.setLayout(csrPanelLayout);
	        csrPanelLayout.setHorizontalGroup(
	            csrPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
	            .addGroup(csrPanelLayout.createSequentialGroup()
	                .addContainerGap()
	                .addComponent(unpublishButton)
	                .addContainerGap(332, Short.MAX_VALUE))
	            .addComponent(csrScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 421, Short.MAX_VALUE)
	        );
	        csrPanelLayout.setVerticalGroup(
	            csrPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
	            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, csrPanelLayout.createSequentialGroup()
	                .addComponent(csrScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 124, Short.MAX_VALUE)
	                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
	                .addComponent(unpublishButton)
	                .addContainerGap())
	        );
	        tablesPanel.add(csrPanel);

	        csPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Available Context Sources"));
	        csPanel.setAlignmentY(0.0F);
	        csTableModel = new ContextSourceTableModel();
	        csTable.addMouseListener(this);
	        csTable.setModel(csTableModel);
	        csTable.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
	        csScrollPane.setViewportView(csTable);
	        csScrollPane.setPreferredSize(new Dimension(0,0));

	        removeButton.setText("Remove");
	        removeButton.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent evt) {
					removeButtonActionPerformed(evt);					
				}	        	
	        });

	        addSensorCSButton.setText("Add Sensor CS");
	        addSensorCSButton.setToolTipText("Adds a SimuContext sensor context source");

	        addStaticCSButton.setText("Add Static CS");
	        addStaticCSButton.setToolTipText("Adds a Static context source from RDF file");
	        addStaticCSButton.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent evt) {
					addStaticCSButtonActionPerformed(evt);					
				}	        	
	        });

	        addDynamicCDButton.setText("Add Dynamic CS");
	        addDynamicCDButton.setToolTipText("Adds a Dynamic context source from Java class file");

	        publishButton.setText("Publish");
	        publishButton.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent evt) {
					publishButtonActionPerformed(evt);					
				}	        	
	        });

	        javax.swing.GroupLayout csPanelLayout = new javax.swing.GroupLayout(csPanel);
	        csPanel.setLayout(csPanelLayout);
	        csPanelLayout.setHorizontalGroup(
	            csPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
	            .addComponent(csScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 421, Short.MAX_VALUE)
	            .addGroup(csPanelLayout.createSequentialGroup()
	                .addContainerGap()
	                .addGroup(csPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
	                    .addComponent(publishButton, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
	                    .addComponent(removeButton, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
	                    .addComponent(addSensorCSButton, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
	                    .addComponent(addStaticCSButton, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
	                    .addComponent(addDynamicCDButton, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
	                .addContainerGap(300, Short.MAX_VALUE))
	        );
	        csPanelLayout.setVerticalGroup(
	            csPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
	            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, csPanelLayout.createSequentialGroup()
	                .addComponent(csScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 95, Short.MAX_VALUE)
	                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
	                .addComponent(publishButton)
	                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
	                .addComponent(removeButton)
	                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
	                .addComponent(addSensorCSButton)
	                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
	                .addComponent(addStaticCSButton)
	                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
	                .addComponent(addDynamicCDButton)
	                .addContainerGap())
	        );
	        tablesPanel.add(csPanel);

	        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
	        this.setLayout(layout);
	        layout.setHorizontalGroup(
	            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
	            .addComponent(requestPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
	            .addComponent(tablesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 437, Short.MAX_VALUE)
	        );
	        layout.setVerticalGroup(
	            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
	            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
	                .addComponent(tablesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 476, Short.MAX_VALUE)
	                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
	                .addComponent(requestPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 56, javax.swing.GroupLayout.PREFERRED_SIZE))
	        );	    
	        
	        //own stuff below
	        
	        rdfFileChooser = new JFileChooser(System.getProperty("user.dir"));
	        rdfFileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
	        rdfFileChooser.setFileFilter(new FileFilter(){
				
				public boolean accept(File f) {				
					if(f.isDirectory() 
							|| f.getName().endsWith(".owl")
							|| f.getName().endsWith(".xml")
							|| f.getName().endsWith(".rdf")
							|| f.getName().endsWith(".n3"))
					{
						return true;
					}
					else
					{
						return false;
					}
				}
				
				public String getDescription() {				
					return "RDF Files";
				}
				
			});
	        
	    }                       
	    
	 
	 
	    // Variables declaration - do not modify
	    private javax.swing.JButton addDynamicCDButton;
	    private javax.swing.JButton addSensorCSButton;
	    private javax.swing.JButton addStaticCSButton;
	    private javax.swing.JComboBox csConceptsComboBox;
	    private javax.swing.JPanel csPanel;
	    private javax.swing.JScrollPane csScrollPane;
	    private javax.swing.JTable csTable;
	    private javax.swing.JPanel csrPanel;
	    private javax.swing.JScrollPane csrScrollPane;
	    private javax.swing.JTable csrTable;
	    private javax.swing.JButton publishButton;
	    private javax.swing.JButton removeButton;
	    private javax.swing.JButton requestContextSourceButton;
	    private javax.swing.JPanel requestPanel;
	    private javax.swing.JPanel tablesPanel;
	    private javax.swing.JButton unpublishButton;
	    private JFileChooser rdfFileChooser;
	    private ContextSourceTableModel csTableModel;
	    private ContextSourceRepositoryTableModel csrTableModel;	    
	    // End of variables declaration  

	    /**
	     * MouseListener methods
	     */
		public void mouseClicked(MouseEvent me) {			
			if(me.getClickCount() > 1 && me.getClickCount() < 3 && me.getButton() == MouseEvent.BUTTON1){								
				VPContextSource vpcs = csTableModel.getContextSource(csTable.getSelectedRow());				
				vpGui.viewContextSource(vpcs);				
			}	
		}
		public void mouseEntered(MouseEvent arg0) {}
		public void mouseExited(MouseEvent arg0) {}
		public void mousePressed(MouseEvent arg0) {}
		public void mouseReleased(MouseEvent arg0) {}

			
}
