package vtt.vp.gui.context;

import java.util.Vector;

import javax.swing.event.TableModelEvent;
import javax.swing.table.AbstractTableModel;

import vtt.vp.context.ContextSourceRepository;
import vtt.vp.context.ContextSourceRepositoryListener;
import vtt.vp.context.source.VPContextSource;

public class ContextSourceRepositoryTableModel extends AbstractTableModel implements ContextSourceRepositoryListener{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	private ContextSourceRepository contextSourceRepository;
	private Vector<VPContextSource> contextSources;
	private String columnNames[] = new String[]{"Name", "Type", "Value"};
	
	public ContextSourceRepositoryTableModel(ContextSourceRepository csr){
		
		contextSourceRepository = csr;
		contextSources = new Vector<VPContextSource>(10);		
		contextSourceRepository.registerListener(this);
		
	}
	
	public VPContextSource getContextSourceInRow(int r){
		return contextSources.elementAt(r);
	}
	
	public int getColumnCount() {		
		return columnNames.length;
	}

	public int getRowCount() {		
		return contextSourceRepository.getContextSourceCount();
	}

	public Object getValueAt(int x, int y) {		

		String returnValue = null;
		
		if(y == 0){
			returnValue = contextSources.elementAt(x).getName();
		}else if(y == 1){
			returnValue = contextSources.elementAt(x).getURI();
		}else if(y == 2){
			returnValue = "toinen";
		}
		
		return returnValue;
		
	}
	
	public Class<String> getColumnClass(int c) {
        return String.class;
    }

	public String getColumnName(int col) {
        return columnNames[col];
    }

	public void contextSourceRegistered(VPContextSource vpcs) {
		contextSources.add(vpcs);	
		fireTableChanged(new TableModelEvent(this));
	}

	public void contextSourceRemoved(VPContextSource vpcs) {
		contextSources.remove(vpcs);	
		fireTableChanged(new TableModelEvent(this));
	}

}
