package vtt.vp.gui.context;

import java.util.Vector;

import javax.swing.event.TableModelEvent;
import javax.swing.table.AbstractTableModel;

import vtt.vp.context.source.VPContextSource;

public class ContextSourceTableModel extends AbstractTableModel {
	
	private static final long serialVersionUID = 1L;
	
	private Vector<VPContextSource> contextSources;
	private String columnNames[] = new String[]{"Name", "Type", "Value"};
	
	public ContextSourceTableModel(){
		contextSources = new Vector<VPContextSource>(10);
	}
	 
	public void addContextSource(VPContextSource vpcs){
		contextSources.add(vpcs);
		fireTableChanged(new TableModelEvent(this));
	}	
	
	public VPContextSource removeContextSource(int i){
		VPContextSource vpcs = contextSources.remove(i);
		fireTableChanged(new TableModelEvent(this));
		return vpcs;
	}
	
	public VPContextSource getContextSource(int i){
		return contextSources.elementAt(i);
	}
	
	public int getColumnCount() {			
		return columnNames.length;
	}

	public int getRowCount() {			
		return contextSources.size();
	}

	public Object getValueAt(int x, int y) {
		
		String returnValue = null;
		
		if(y == 0){
			returnValue = contextSources.elementAt(x).getName();
		}else if(y == 1){			
			int type = contextSources.elementAt(x).getType();			
			if(type == VPContextSource.SENSOR_CS_TYPE)
				returnValue = "Sensor";
			else if(type == VPContextSource.STATIC_CS_TYPE)
				returnValue = "Static";
			else if(type == VPContextSource.DYNAMIC_CS_TYPE)
				returnValue = "Dynamic";			
		}else if(y == 2){
			returnValue = contextSources.elementAt(x).getValueString();
		}
		
		return returnValue;
		
	}
	
	public Class<String> getColumnClass(int c) {
        return String.class;
    }

	public String getColumnName(int col) {
        return columnNames[col];
    }
	
 }