package vtt.vp.library;

import java.awt.image.BufferedImage;

/**
 * Class IconSet stores 4 IconImages of an item in isometric perspective.
 * IconSet is aware of the grid dimensions of the icon.
 * @author tptoni
 *
 */
public class IconSet {
	
	private String iconName;
	private BufferedImage north;
	private BufferedImage east;
	private BufferedImage south;
	private BufferedImage west;	
	private int iconGridWidth;
	private int iconGridHeight;
	private int iconWidth;
	private int iconHeight;
	
	public IconSet(String name, 
			BufferedImage n,
			BufferedImage e,
			BufferedImage s,
			BufferedImage w,			
			int width,
			int height){
		
		iconName = name;
		north = n;
		east = e;
		south = s;
		west = w;			
		iconGridWidth = width;
		iconGridHeight = height;
		if(north != null){
			iconWidth = north.getWidth();
			iconHeight = north.getHeight();
		}
		
	}
	
	public String getImageName(){
		return iconName;
	}

	public BufferedImage getImageNorth(){
		return north;
	}
	
	public BufferedImage getImageEast(){
		return east;
	}
	
	public BufferedImage getImageSouth(){
		return south;
	}
	
	public BufferedImage getImageWest(){
		return west;
	}	
	
	public int getImageWidth(){
		return iconWidth;
	}
	
	public int getImageHeight(){
		return iconHeight;
	}
	
	public int getGridWidth(){
		return iconGridWidth;
	}
	
	public int getGridHeight(){
		return iconGridHeight;
	}
	
}

