package vtt.vp.utils;

import java.awt.Color;
import java.awt.Graphics;

import javax.swing.JComponent;

/**
 * Class Grid is used in the base of visualizations. Grid paints 20*20 grid.
 */     
public class Grid extends JComponent{
	
	 private static final long serialVersionUID = 555;
	
	 int gridW;
	 int gridH;  	   
	   
	 /**
	  * Class constructor that specifies the size of the grid
	  * 
	  * @param w		width of the grid in grid squares
	  * @param h		height of the grid in grid squares     
	  */
	 public Grid(int w, int h){  		     		   
		gridW = w;
		gridH = h;  		     		   
		//this is the minimum size of a grid
		if(gridW<1) gridW=1;
		if(gridH<1) gridH=1;  		     		   		   
		this.setBounds(0,0,gridW*20+1,gridH*20+1);  		   
	 }
	   
	 /**
	  * Paints the Grid
	  */
	 public void paint(Graphics g){	   		
		g.setColor(new Color(210,210,210));
		for(int i=0 ; i<gridW ; i++) g.drawLine(i*20,0,i*20,gridH*20);	
		for(int i=0 ; i<gridH ; i++) g.drawLine(0,i*20,gridW*20,i*20);
		g.drawLine(gridW*20,0,gridW*20,gridH*20);
		g.drawLine(0,gridH*20,gridW*20,gridH*20);		   
	 }	   
		   
}
