package vtt.vp.utils;

import java.awt.Color;
import java.awt.Graphics;

import javax.swing.JComponent;

/**
 * Class IsometricGrid is used in the base of visualizations. 
 * IsometricGrid paints 20*20 grid in isometric perspective.
 */	      	 
public class IsometricGrid extends JComponent{

	static final long serialVersionUID = 142;
	
    int gridW;
    int gridH;         
   
    /**
	  * Class constructor that specifies the size of the grid
	  * 
	  * @param w		width of the grid in grid squares
	  * @param h		height of the grid in grid squares     
	  */
    public IsometricGrid(int w, int h){	      		   
	   gridW = w;
	   gridH = h;	   
	   //this is the minimum size of the visualization screen in grids
	   if(gridW<1) gridW=1;
	   if(gridH<1) gridH=1;     		   
	   this.setSize(((gridW+gridH)*16), ((gridW+gridH)*8));		   	   
   }
   
   public void paint(Graphics g){		   
	   g.setColor(new Color(210,210,210));
	   for(int i=0 ; i<gridW ; i++)
		   g.drawLine((gridH+i)*16, i*8, i*16, (gridH+i)*8);	   
	   for(int i=0 ; i<gridH ; i++)
		   g.drawLine((gridH-i)*16, i*8, (gridW+gridH-i)*16, (gridW+i)*8);
	   g.drawLine((gridW+gridH)*16, gridW*8, gridW*16, (gridW+gridH)*8);
	   g.drawLine(0, gridH*8, gridW*16, (gridW+gridH)*8);
	   
   } 	      	 
	
}

