package vtt.vp.view;

import javax.swing.JComponent;

/**
 * Abstract base class for VantagePoint items. This class implements basic methods
 * that all Items must have. The implementation of a more defined Item is left
 * to the subclasses of this abstract class.
 * @author tptoni
 *
 */
public abstract class VPItem extends JComponent implements VisualComponent {

	public static final int ITEM_SOUTH = 0;
	public static final int ITEM_WEST = 1;
	public static final int ITEM_NORTH = 2;
	public static final int ITEM_EAST = 3;
	
	private String URI;					//URI of this VPItem instance	
	private String parentAreaURI;		//URI of the parent area	
	
	public VPItem(String URI){
		super();
		this.URI = URI;
	}
	
	/**
	 * Converts item to String representation
	 */
	public String toString(){	
		return URI;		
	}	
	
	//
	//VisualComponent interface methods
	//
	
	public String getURI(){
		return this.URI;
	}
	
	public String getLocalName(){
		
		int index = this.URI.indexOf("#");		
		if(index == 0)
			return this.URI;
		else
			return this.URI.substring(index+1, this.URI.length());
		
	}	
	
	public String getParentAreaURI(){
		return this.parentAreaURI;
	}
	
	public void setParentAreaURI(String URI){
		this.parentAreaURI = URI;
	}	
	
}
