package vtt.vp.view;

/**
 * Interface VisualComponent gathers the common methods for VPArea and
 * VPItem Classes. When handling VPAreas and VPItems it is not necessary
 * to know the type and VisualComponent interface hides it.
 * @author tptoni
 *
 */
public interface VisualComponent {

	String getURI();
	String getLocalName();
		
	String getParentAreaURI();
	void setParentAreaURI(String URI);
	
	boolean isHighlighted();
	void setHighlight(boolean b);
	
	boolean isSelected();
	void setSelected(boolean b);
	
}
